
!Object methodsFor: '*LazyRabbit' stamp: 'hjo 1/30/2009 17:42'!
setDefault: defaultSymbol for: anObject withSetter: setter

	"I am not nil, so do nothing."! !

!Browser methodsFor: '*LazyRabbit' stamp: 'hjo 4/9/2009 13:43'!
createLazyRabbitVar

	| newVarName |
	newVarName := FillInTheBlank
 	    request: 'new inst var name'
 	    initialAnswer:  ''
    		centerAt: Sensor cursorPoint.
	newVarName isEmpty ifFalse: [ self selectedClass addLazyInstVarName: newVarName ]! !

!Browser methodsFor: '*LazyRabbit-class function' stamp: 'hjo 4/9/2009 13:38'!
shiftedClassListMenu: aMenu
	"Set up the menu to apply to the receiver's class list when the shift key is down"

	^ aMenu addList: #(
			-
			('unsent methods'			browseUnusedMethods	'browse all methods defined by this class that have no senders')
			('unreferenced inst vars'	showUnreferencedInstVars	'show a list of all instance variables that are not referenced in methods')
			('unreferenced class vars'	showUnreferencedClassVars	'show a list of all class variables that are not referenced in methods')
			('subclass template'			makeNewSubclass		'put a template into the code pane for defining of a subclass of this class')
			-
			('sample instance'			makeSampleInstance		'give me a sample instance of this class, if possible')
			('inspect instances'			inspectInstances			'open an inspector on all the extant instances of this class')
			('inspect subinstances'		inspectSubInstances		'open an inspector on all the extant instances of this class and of all of its subclasses')
			-
			('add all meths to current chgs'		addAllMethodsToCurrentChangeSet
																'place all the methods defined by this class into the current change set')
			('create inst var accessors'	createInstVarAccessors	'compile instance-variable access methods for any instance variables that do not yet have them')
			('add lazy rabbit'	createLazyRabbitVar	'adds lazy rabbit variable & accessors')
			-
			('more...'					offerUnshiftedClassListMenu	'return to the standard class-list menu'))! !

!UndefinedObject methodsFor: '*LazyRabbit' stamp: 'hjo 1/30/2009 17:42'!
setDefault: defaultSymbol for: anObject withSetter: setter

	anObject perform: setter with: (anObject perform: defaultSymbol)! !

!Class methodsFor: '*LazyRabbit' stamp: 'hjo 3/4/2009 15:13'!
addLazyInstVarName: newInstVarName

	self addInstVarName: newInstVarName.
	self createLazyInstVarAccessors: newInstVarName! !

!Class methodsFor: '*LazyRabbit' stamp: 'hjo 3/24/2009 14:43'!
addLazyInstVarNameWithDefault: variableName 

	self addInstVarName: variableName.
	self createLazyInstVarAccessorsWithDefault: variableName! !

!Class methodsFor: '*LazyRabbit' stamp: 'hjo 3/4/2009 15:08'!
createLazyInstVarAccessors

	self instVarNames do: [:v| self createLazyInstVarAccessors: v ].! !

!Class methodsFor: '*LazyRabbit' stamp: 'hjo 3/24/2009 12:44'!
createLazyInstVarAccessors: variableName

	self createLazyInstVarSetter: variableName.
	self createLazyInstVarDefault: variableName.
	self createLazyInstVarGetter: variableName.! !

!Class methodsFor: '*LazyRabbit' stamp: 'hjo 3/24/2009 15:54'!
createLazyInstVarAccessorsWithDefault: variableName

	| defaultCode |
	defaultCode := FillInTheBlank
			request: 'Default Generator code'
			initialAnswer:  '^0'
			centerAt: Sensor cursorPoint.
	defaultCode isEmpty ifTrue: [ defaultCode := 'self shouldBeImplemented' ].
	self createLazyInstVarSetter: variableName.
	self createLazyInstVarDefault: variableName withSource: defaultCode.
	self createLazyInstVarGetter: variableName.! !

!Class methodsFor: '*LazyRabbit' stamp: 'hjo 3/24/2009 15:55'!
createLazyInstVarDefault: variableName.

	self createLazyInstVarDefault: variableName withSource: 'self shouldBeImplemented' 
! !

!Class methodsFor: '*LazyRabbit' stamp: 'hjo 3/24/2009 13:00'!
createLazyInstVarDefault: variableName withSource: aByteString 

	(self canUnderstand: ('default', variableName capitalized) asSymbol)
		ifFalse: [ self compile: ('default', variableName capitalized , '

	"Return a default object for instance variable ',variableName,'."
	', aByteString)
		classified: 'defaults' notifying: nil].
! !

!Class methodsFor: '*LazyRabbit' stamp: 'hjo 3/24/2009 12:44'!
createLazyInstVarGetter: variableName

	(self canUnderstand: variableName asSymbol)
	ifFalse: [ self compile: (variableName ,
'

	',variableName,' setDefault: #default', variableName capitalized ,' for: self withSetter: #',variableName,': .
	^',
variableName)
		classified: 'accessing' notifying: nil].
! !

!Class methodsFor: '*LazyRabbit' stamp: 'hjo 3/24/2009 12:58'!
createLazyInstVarSetter: variableName

	(self canUnderstand: (variableName,':') asSymbol)
		ifFalse: [ self compile: (variableName ,': anObject
		
	',variableName,' := anObject')
		classified: 'accessing' notifying: nil].! !
